export default class NV_Error {
	#messages = [];
	#code = null;
	get isEmpty() {
		return !this.#messages.length;
	}
	get message() {
		return this.#messages[0];
	}
	get messages() {
		return this.#messages;
	}
	get code() {
		return this.#code;
	}
	set code(val) {
		this.#code = val;
		return this;
	}
	constructor(message, code) {
		if (message) {
			this.#messages.push(message)
		}
		if (code) {
			this.#code = code;
		}
		return this;
	}
	attach(message) {
		if (message) {
			this.#messages.push(message)
		}
		return this;
	}
	detach(message) {
		if (message) {
			var index = this.#messages.indexOf(message);
			if (index > -1) {
				this.#messages.splice(index,1);
			}
		}
		return this;
	}
}

global.is_nv_error = (object)=>{
	return object instanceof NV_Error;
}