import * as path from 'path'
import { pathToFileURL } from 'url'
import { createRequire } from "module";

//读取命令行参数
import minimist from "minimist";
const process_args = minimist(process.argv)

export default async ()=>{
	global.nv_current_theme_folder = null;
	global.nv_error_theme_folder = "";

	var all_themes = nv_theme_list();
	var setted_theme_folder = get_option('_nv_selected_theme_folder','default');
	// 存在被选择的主题
	if ( all_themes.filter(t=>t.folder == setted_theme_folder && !t.error)[0] ) {
		nv_current_theme_folder = setted_theme_folder;
		nv_log(
			'当前主题：',
			nv_log.warning(setted_theme_folder)
		)

		await import( pathToFileURL(path.join(process.cwd(),`./nv-themes/${setted_theme_folder}/function.js`)) )
		.then(res=>{
			if (typeof(res) == 'function') {
				res();
			}
		})
		.catch(e=>{
			nv_error_theme_folder = setted_theme_folder;
			nv_log(
				nv_log.error('主题错误：'),
				e
			)
		})

		if (process_args.docker && nv_error_theme_folder) {
			nv_log(
				nv_log.warning('正式环境：'),
				'主题错误尝试使用CSR模式！！！请删除导致异常的主题！！！'
			)
			set_frontstage_rendering_mode('CSR', path.join(import.meta.dirname,"../nv-statics/install-complete/web/") );
		}


	} else {
		// 首次安装成功，未启用主题
		nv_log(
			'当前主题：',
			nv_log.warning('未加载任何主题！')
		)

		await import( pathToFileURL(path.join(process.cwd(),`./nv-statics/install-complete/function.js`)) )
		.then(res=>{
			if (typeof(res) == 'function') {
				res();
			}
		})
		.catch(e=>{
			nv_log(
				nv_log.error('安装错误：nvPress文件丢失'),
				e
			)
		})
	}
}