export default ()=>{
	// 升级版本后可能需要处理数据
	add_action('async:_nv_init',next=>{
		if ( get_option('_db_ver',0) < 2022053001 ) {
			var posts = nvdb.posts.find(r=>{
				return r.content
					&& typeof r.content === 'object'
					&& r.content.constructor === Object
					&& Array.isArray(r.content.blocks);
			},['id','content']);

			var changeType = (content) => {
				if (content
					&& typeof content === 'object'
					&& content.constructor === Object
					&& Array.isArray(content.blocks) ) {
					return {
						...content,
						blocks: content.blocks.map(block=>{
							if (block.type == 'tip') {
								block.type = 'pandastudio/tip';
							}
							if (block.type == 'collapse') {
								block.type = 'pandastudio/collapse';
								block.data.content = changeType(block.data.content);
							}
							return block;
						})
					}
				} else {
					return content;
				}
			}

			posts.forEach(({id,content})=>{
				nvdb.posts.setColumn(r=>r.id==id,{
					content: changeType(content)
				})
			})
			console.log('数据已更新')
			// 设置 _db_ver
			set_option('_db_ver',2022053001);
		}

		// 将模块 code 的 code 数据变更为 pre
		if ( get_option('_db_ver',0) < 20220719001 ) {
			var posts = nvdb.posts.find(r=>{
				return r.content
					&& typeof r.content === 'object'
					&& r.content.constructor === Object
					&& Array.isArray(r.content.blocks);
			},['id','content']);

			var changeType = (content) => {
				if (content
					&& typeof content === 'object'
					&& content.constructor === Object
					&& Array.isArray(content.blocks) ) {
					return {
						...content,
						blocks: content.blocks.map(block=>{
							if (block.type == 'code') {
								if (block.data.code) {
									block.data.pre = block.data.code;
									delete block.data.code;
								}
							}
							return block;
						})
					}
				} else {
					return content;
				}
			}

			posts.forEach(({id,content})=>{
				nvdb.posts.setColumn(r=>r.id==id,{
					content: changeType(content)
				})
			})
			console.log('数据已更新')
			// 设置 _db_ver
			set_option('_db_ver',20220719001);
		}
		next();
	},1);
}