export default ()=>{
	add_menu_page({
		page_title: "概览",
		menu_title: "概览",
		menu_slug: "dashboard",
		power: 0,
		position: 0,
		icon: "<i class='el-icon-odometer'></i>",
		_component: "dashboard",
	})

	register_posttype('page',{
		label: "页面",
		labels: {
			singular_name: "页面",
			all_items: "所有页面",
			add_new_item: "新建页面",
		},
		show_ui: true,
		supports: ['title','editor','author','comments','excerpt'], //要支持密码，必须写上 password
		hierarchical: true,
	})

	register_posttype('article',{
		label: "文章",
		menu_icon: "<i class='el-icon-edit-outline'></i>",
		labels: {
			singular_name: "文章",
			all_items: "所有文章",
			add_new_item: "写文章",
		},
		show_ui: true,
		supports: ['title','editor','author','comments','excerpt'], //要支持密码，必须写上 password
	})

	add_post_type_support('article','thumbnail');

	register_taxonomy('category','article',{
		hierarchical: true,
		labels: {
			name: "文章分类",
			singular_name: "文章分类",
			add_new_item: "添加分类",
			edit_item: "编辑分类",
			parent_item: "父级分类",
			delete_item: "删除分类",
		}
	})
	register_taxonomy('tag','article',{
		labels: {
			name: "文章标签",
			singular_name: "文章标签",
			add_new_item: "添加标签",
			edit_item: "编辑标签",
			delete_item: "删除标签",
		}
	})

	add_menu_page({
		page_title: "媒体与附件",
		menu_title: "媒体与附件",
		menu_slug: "media-library",
		power: 6,
		position: 40,
		icon: "<i class='el-icon-picture-outline-round'></i>",
		_component: "mediaLibrary",
	})

	add_menu_page({
		page_title: "评论",
		menu_title: "评论",
		menu_slug: "comments",
		power: 8,
		position: 50,
		icon: "<i class='el-icon-chat-dot-round'></i>",
		_component: "comments",
	})

	// 并不是一定现实外观菜单。只有当它内部有children时才显示。控制方式在：后台sidebar.vue文件
	// v-if="parent.children || parent._component || parent.component_url"
	add_menu_page({
		page_title: "外观",
		menu_title: "外观",
		menu_slug: "appearance",
		power: 10,
		position: 60,
		icon: "<i class='el-icon-brush'></i>",
	})

	add_menu_page({
		page_title: "套件中心",
		menu_title: "套件中心",
		menu_slug: "packages",
		power: 10,
		position: 70,
		icon: "<i class='el-icon-shopping-bag-2'></i>",
	})

	add_submenu_page({
		parent_slug: "packages",
		page_title: "已安装",
		menu_title: "已安装",
		menu_slug: "installed-packages",
		power: 10,
		position: 50,
		_component: "installedPackages"
	})

	add_submenu_page({
		parent_slug: "packages",
		page_title: "获取套件",
		menu_title: "获取套件",
		menu_slug: "package-hub",
		power: 10,
		position: 100,
		_component: "packageHub",
		child_routes: [{
			path: "",
			name: "package-hub-home",
			_component: "packageHubHome",
			position: 2,
		},{
			path: "list",
			name: "package-hub-list",
			_component: "packageHubList",
			position: 3,
		},{
			path: "detail",
			name: "package-hub-detail",
			_component: "packageHubDetail",
			position: 4,
		}]
	})

	add_menu_page({
		page_title: "用户",
		menu_title: "用户",
		menu_slug: "users",
		power: 10,
		position: 80,
		icon: "<i class='el-icon-user'></i>",
	})

	add_submenu_page({
		parent_slug: "users",
		page_title: "所有用户",
		menu_title: "所有用户",
		menu_slug: "user-list",
		power: 10,
		position: 10,
		_component: "userList"
	})

	add_submenu_page({
		parent_slug: "users",
		page_title: "邀请码",
		menu_title: "邀请码",
		menu_slug: "invite-list",
		power: 10,
		position: 10,
		_component: "inviteList"
	})

	add_menu_page({
		page_title: "设置",
		menu_title: "设置",
		menu_slug: "settings",
		power: 10,
		position: 90,
		icon: "<i class='el-icon-setting'></i>",
	})

	add_submenu_page({
		parent_slug: "settings",
		page_title: "常规",
		menu_title: "常规",
		menu_slug: "settings-general",
		power: 10,
		position: 10,
		_component: "settingsGeneral"
	})

	add_submenu_page({
		parent_slug: "settings",
		page_title: "媒体",
		menu_title: "媒体",
		menu_slug: "settings-media",
		power: 10,
		position: 10,
		_component: "settingsMedia"
	})

	add_submenu_page({
		parent_slug: "settings",
		page_title: "评论",
		menu_title: "评论",
		menu_slug: "settings-comments",
		power: 10,
		position: 10,
		_component: "settingsComments"
	})

	add_submenu_page({
		parent_slug: "settings",
		page_title: "用户",
		menu_title: "用户",
		menu_slug: "settings-users",
		power: 10,
		position: 10,
		_component: "settingsUsers"
	})

	add_submenu_page({
		parent_slug: "settings",
		page_title: "Email 服务",
		menu_title: "Email 服务",
		menu_slug: "settings-email",
		power: 10,
		position: 10,
		_component: "settingsEmail"
	})

	//不显示菜单的router
	add_menu_page({
		page_title: "编辑用户",
		menu_title: "编辑用户",
		menu_slug: "user-edit",
		power: 10,
		_component: "editUser",
		highlight_menu: "user-list"
	})

	add_menu_page({
		page_title: "个人资料",
		menu_title: "个人资料",
		menu_slug: "user-edit-self",
		power: 0,
		_component: "editUserSelf",
		highlight_menu: "user-list"
	})
}