export default ()=>{
	register_rest_route('nv','get-invite-list',{
		methods: 'post',
		callback(data,req) {
			return nv_get_invite_list();
		},
		permission_callback: power=>power >= 10,
	});

	register_rest_route('nv','insert-invite',{
		methods: 'post',
		callback(data,req) {
			const {power,deprecate_time} = data;
			var code = nv_create_invite(power,deprecate_time);
			if (is_nv_error(code)) {return code;}
			return {code};
		},
		permission_callback: power=>power >= 10,
	});

	//列表页批量删除、列表页删除单个
	register_rest_route('nv','remove-invites',{
		methods: 'post',
		callback(data,req) {
			const {ids} = data;
			if (!ids) {
				return new NV_Error("参数错误");
			}
			ids.forEach(id=>{
				nv_delete_invite(id);
			})
			return {};
		},
		permission_callback: power=>power >= 10,
	});
}